//+------------------------------------------------------------------+
//|                                                     News gap.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, vn4x vangsaigon.com"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

extern bool  ECN_Broker = false;
extern double Lot =0.1; 
extern int  StopLoss = 5;
extern int  TakeProfit = 50;
extern int  Magic = 12;
extern int slipage =3;

double PriceToOpen;  
double gd_point;
double gd_bprice, gd_sprice;
int result;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   gd_point =Point;
   if (Digits == 3 || Digits == 5) {
      slipage = 10 * slipage;
      gd_point =10*Point;
   }
   PriceToOpen = Bid;  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(orderCount(-1) < 1 ) {     
      gd_bprice = PriceToOpen+StopLoss*gd_point;
      gd_sprice = PriceToOpen-StopLoss*gd_point;     
      sendOrder(Symbol(),OP_BUYSTOP,Lot,gd_bprice,PriceToOpen,PriceToOpen+TakeProfit*gd_point,"EA",Magic);
      sendOrder(Symbol(),OP_SELLSTOP,Lot,gd_sprice,PriceToOpen,PriceToOpen-TakeProfit*gd_point,"EA",Magic);    
   }   
    
   if(orderCount(0) + orderCount(1)< 1 ) { 
      for (int i = 0; i < OrdersTotal(); i++) {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderMagicNumber() == Magic && OrderCloseTime() == 0) {
            
            switch (OrderType()) {
            case OP_BUYSTOP:
                     if( Bid < PriceToOpen ) OrderModify(OrderTicket(), Bid+StopLoss*gd_point, Bid,Bid+TakeProfit*gd_point , 0, CLR_NONE);
            case OP_SELLSTOP:
                     if( Bid > PriceToOpen ) OrderModify(OrderTicket(), Bid-StopLoss*gd_point, Bid,Bid-TakeProfit*gd_point, 0, CLR_NONE);
            }
         }
      }
   }    
  PriceToOpen = Bid;    
  
  
  }

//+------------------------------------------------------------------+
int sendOrder(string a_symbol_0, int a_cmd_8, double a_lots_12, double a_price_20, double a_price_28, double a_price_36,string a_comment, int a_magic) {
   int l_error_64; int l_ticket_60;
   int l_slippage_68 = slipage;
   double l_price_72 = a_price_28;
   double l_price_80 = a_price_36;
   color l_color_92 = Green;
   if (a_cmd_8 == OP_SELL) l_color_92 = Red;
   if (ECN_Broker) {
   l_ticket_60 = OrderSend(a_symbol_0, a_cmd_8, a_lots_12, a_price_20, l_slippage_68, 0, 0, a_comment, a_magic, 0, l_color_92);
   if (l_ticket_60 > 0 ) OrderModify(l_ticket_60, OrderOpenPrice(), a_price_28, a_price_36, 0);
   } else {
   l_ticket_60 = OrderSend(a_symbol_0, a_cmd_8, a_lots_12, a_price_20, l_slippage_68, a_price_28, a_price_36, a_comment, a_magic, 0, CLR_NONE);
   }
   if (l_ticket_60 <= 0) {
      l_error_64 = GetLastError();
      return (0);
   }
   return (1);
}


int orderCount(int type)
{
 int total = OrdersTotal();
 int oc = 0;
 for(int cnt=0; cnt<=total; cnt++)
  {OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol()!=Symbol()) continue;
   if(OrderMagicNumber()==Magic && (OrderType()==type || type==-1))
     oc+=1;}
 return(oc);
}